unit utils;

interface
uses classes;

function  killproc(numb:string):boolean;
function clientencodeid(serverid,clientid:Integer;clientip:string):string;
function serverdecodeid(serverid:integer; const clientip,s:string):integer;
const version:shortstring=('FADManager beta 10');

type TLogFile=class(TStringlist)
procedure flushlog;
procedure addlog(const s:String);
public
fn:string;
end;
function  processexists(numb:tstringlist):boolean;
procedure ChangeReg(StrName,Appname: ShortString; delete: boolean);
function  oneprocessexists(const numb:string):boolean;
Function getfilesize(const s:string):integer;
Function Updatecrc32(Curbyte : Byte; Curcrc : LongInt) : LongInt;
Function Crc32(Var S;Length,crc:longint):LongInt;
function filecrc32(const fn:String):Longint;
procedure buildfilescrc(var filelist,reslist:TStringlist;const dir:String);
procedure builddiflist(var filelist,reslist:TStringlist;const dir:String);
function findrecentfile(const fn:string;var dirs:TStringlist):string;
function getprocenv:Integer;

type
  PByteArrayext = ^TByteArrayext;
  TByteArrayext = array[0..32767*8] of Byte;
function getpcname:string;
implementation
uses tlhelp32,windows,sysutils,registry;
function findrecentfile(const fn:string;var dirs:TStringlist):string;
var s,files:string;
filedate,date:tdatetime;
i:integer;
begin
filedate:=0;
files:='';
for I:=0 to dirs.count-1 do begin
s:=dirs.strings[i]+fn;
if fileexists(s) then begin
date:=FileDateToDateTime (fileage(s));
if date>filedate then begin
files:=s;
filedate:=date;

end;
end;
end;
result:=files;
end;

{function getpcname:shortstring;
var dw:DWord;
s:string;
begin
     dw:=64;
     GetComputerName(pchar(s), dw);
     SetLength(S, dw);

result:=s;
end;}



procedure buildfilescrc(var filelist,reslist:TStringlist;const dir:String);
var i,crc:Integer;
begin
with filelist do begin
for i:=0 to count-1 do begin
crc:=filecrc32(dir+strings[i]);
if crc<>-1 then reslist.add(strings[i]+'='+inttostr(crc));
end;
end;
end;
procedure builddiflist(var filelist,reslist:TStringlist;const dir:String);
var i,crc:Integer;
s:string;
begin
with filelist do begin
for i:=0 to count-1 do begin
crc:=filecrc32(dir+names[i]);
s:=values[names[i]];
if (crc<>strtoint(s)) then reslist.add(names[i]);
end;
end;
end;




function filecrc32(const fn:String):Longint;
var f:TFilestream;
buf:array[0..1024*70] of byte;
crc,len:Integer;
begin
result:=-1;
crc:=-1;
if not fileexists(fn) then exit;
try
f:=tFilestream.create(fn,fmopenread+fmsharedenynone);
repeat
len:=f.read(buf,sizeof(buf));
if len<>0 then crc:=crc32(buf,len,crc);
until len=0;
finally
f.free;
end;
result:=crc;
end;



Function Crc32(Var S;Length,crc:longint):LongInt;
Var I:Word;
  Z:Byte;
  T:LongInt;
Begin
result:=-1;
  If Length=0 Then Exit;
  For I:=0 To Length-1 Do Begin
    Crc:=Updatecrc32(TByteArrayext(S)[I],Crc);
  End;
  Crc32:=Crc;
End;

Const
  Crc32Table : Array[0..255] Of Cardinal = (
    $00000000, $77073096, $Ee0E612C, $990951Ba, $076Dc419, $706Af48F, $E963A535,
    $9E6495A3, $0Edb8832, $79Dcb8A4, $E0D5E91E, $97D2D988, $09B64C2B, $7Eb17Cbd,
    $E7B82D07, $90Bf1D91, $1Db71064, $6Ab020F2, $F3B97148, $84Be41De, $1Adad47D,
    $6Ddde4Eb, $F4D4B551, $83D385C7, $136C9856, $646Ba8C0, $Fd62F97A, $8A65C9Ec,
    $14015C4F, $63066Cd9, $Fa0F3D63, $8D080Df5, $3B6E20C8, $4C69105E, $D56041E4,
    $A2677172, $3C03E4D1, $4B04D447, $D20D85Fd, $A50Ab56B, $35B5A8Fa, $42B2986C,
    $Dbbbc9D6, $Acbcf940, $32D86Ce3, $45Df5C75, $Dcd60Dcf, $Abd13D59, $26D930Ac,
    $51De003A, $C8D75180, $Bfd06116, $21B4F4B5, $56B3C423, $Cfba9599, $B8Bda50F,
    $2802B89E, $5F058808, $C60Cd9B2, $B10Be924, $2F6F7C87, $58684C11, $C1611Dab,
    $B6662D3D, $76Dc4190, $01Db7106, $98D220Bc, $Efd5102A, $71B18589, $06B6B51F,
    $9Fbfe4A5, $E8B8D433, $7807C9A2, $0F00F934, $9609A88E, $E10E9818, $7F6A0Dbb,
    $086D3D2D, $91646C97, $E6635C01, $6B6B51F4, $1C6C6162, $856530D8, $F262004E,
    $6C0695Ed, $1B01A57B, $8208F4C1, $F50Fc457, $65B0D9C6, $12B7E950, $8Bbeb8Ea,
    $Fcb9887C, $62Dd1Ddf, $15Da2D49, $8Cd37Cf3, $Fbd44C65, $4Db26158, $3Ab551Ce,
    $A3Bc0074, $D4Bb30E2, $4Adfa541, $3Dd895D7, $A4D1C46D, $D3D6F4Fb, $4369E96A,
    $346Ed9Fc, $Ad678846, $Da60B8D0, $44042D73, $33031De5, $Aa0A4C5F, $Dd0D7Cc9,
    $5005713C, $270241Aa, $Be0B1010, $C90C2086, $5768B525, $206F85B3, $B966D409,
    $Ce61E49F, $5Edef90E, $29D9C998, $B0D09822, $C7D7A8B4, $59B33D17, $2Eb40D81,
    $B7Bd5C3B, $C0Ba6Cad, $Edb88320, $9Abfb3B6, $03B6E20C, $74B1D29A, $Ead54739,
    $9Dd277Af, $04Db2615, $73Dc1683, $E3630B12, $94643B84, $0D6D6A3E, $7A6A5Aa8,
    $E40Ecf0B, $9309Ff9D, $0A00Ae27, $7D079Eb1, $F00F9344, $8708A3D2, $1E01F268,
    $6906C2Fe, $F762575D, $806567Cb, $196C3671, $6E6B06E7, $Fed41B76, $89D32Be0,
    $10Da7A5A, $67Dd4Acc, $F9B9Df6F, $8Ebeeff9, $17B7Be43, $60B08Ed5, $D6D6A3E8,
    $A1D1937E, $38D8C2C4, $4Fdff252, $D1Bb67F1, $A6Bc5767, $3Fb506Dd, $48B2364B,
    $D80D2Bda, $Af0A1B4C, $36034Af6, $41047A60, $Df60Efc3, $A867Df55, $316E8Eef,
    $4669Be79, $Cb61B38C, $Bc66831A, $256Fd2A0, $5268E236, $Cc0C7795, $Bb0B4703,
    $220216B9, $5505262F, $C5Ba3Bbe, $B2Bd0B28, $2Bb45A92, $5Cb36A04, $C2D7Ffa7,
    $B5D0Cf31, $2Cd99E8B, $5Bdeae1D, $9B64C2B0, $Ec63F226, $756Aa39C, $026D930A,
    $9C0906A9, $Eb0E363F, $72076785, $05005713, $95Bf4A82, $E2B87A14, $7Bb12Bae,
    $0Cb61B38, $92D28E9B, $E5D5Be0D, $7Cdcefb7, $0Bdbdf21, $86D3D2D4, $F1D4E242,
    $68Ddb3F8, $1Fda836E, $81Be16Cd, $F6B9265B, $6Fb077E1, $18B74777, $88085Ae6,
    $Ff0F6A70, $66063Bca, $11010B5C, $8F659Eff, $F862Ae69, $616Bffd3, $166Ccf45,
    $A00Ae278, $D70Dd2Ee, $4E048354, $3903B3C2, $A7672661, $D06016F7, $4969474D,
    $3E6E77Db, $Aed16A4A, $D9D65Adc, $40Df0B66, $37D83Bf0, $A9Bcae53, $Debb9Ec5,
    $47B2Cf7F, $30B5Ffe9, $Bdbdf21C, $Cabac28A, $53B39330, $24B4A3A6, $Bad03605,
    $Cdd70693, $54De5729, $23D967Bf, $B3667A2E, $C4614Ab8, $5D681B02, $2A6F2B94,
    $B40Bbe37, $C30C8Ea1, $5A05Df1B, $2D02Ef8D
    );
Function Updatecrc32(Curbyte : Byte; Curcrc : LongInt) : LongInt;
    {-Return the updated 32bit CRC}
    {-Normally a good candidate for basm, but Delphi32's code
      generation couldn't be beat on this one!}
      Var L:Pointer;
      Type Crc32Tbl=Array[0..255] Of LongInt;
        Tbl=^Crc32Tbl;

      Begin
        {    UpdateCrc32 := Tbl(@_Crc32Table)^[Byte(CurCrc xor CurByte)] xor
                     ((CurCrc shr 8) and $00FFFFFF);}

        Updatecrc32 := Crc32Table[Byte(Curcrc XOr Curbyte)] XOr
        ((Curcrc ShR 8) And $00Ffffff);
        {l:=@_crc32Table;}
      End;


Function getfilesize(const s:string):integer;
var
   f: file of Byte;

begin
if not fileexists(s) then begin
getfilesize:=-1;
exit;
end;
{$I-}
    AssignFile(f, s);
    Reset(f);
    getfilesize := FileSize(f);
    CloseFile(f);
{$I+}

end;


Function Decval(CH : Char) : Byte;

Begin
  Decval := 0;
  If ((CH>='0') And (CH<='9')) Then
    Decval := Ord(CH)-Ord('0');
  If ((CH>='A') And (CH<='F')) Then
    Decval := Ord(CH)-Ord('A')+$0A;
  If ((CH>='a') And (CH<='f')) Then
    Decval := Ord(CH)-Ord('a')+$0A;
End;

Function Hex2Dec(const S : Shortstring) : integer;
Var
  I     : Byte;
  Tmp ,  Place : integer;
Begin
  I := Ord(S[0]);
  Place := 1;
  Tmp := 0;
  While (I>0) Do Begin
    Tmp := Tmp+Place*Decval(S[I]);
    	I:=I-1;
    	Place := Place*$10;
  End;
  Hex2Dec := Tmp;
  {    writeln('hex2dec(',s,') = ',tmp);}
End;

function expandtostring16(const s:String):string;
var ress:String;
I:integer;
begin
ress:=s;
for I:=length(s) to 16 do begin
ress:=ress+' ';
end;
expandtostring16:=ress;
end;

function clientencodeid(serverid,clientid:Integer;clientip:string):string;
type pxorarray=^txorarray;
txorarray=array[1..4] of integer;
var j,clientsendid:integer;
myclientip,clientstring:string;
begin
clientsendid:=clientid;
myclientip:=expandtostring16(clientip);
for j:=1 to 4 do begin
clientsendid:=clientsendid xor pxorarray(@myclientip[1])^[j];
end;
clientsendid:=clientsendid xor serverid;
clientstring:=inttohex(clientsendid,8);
clientencodeid:=clientstring;
end;

function serverdecodeid(serverid:integer; const clientip,s:string):integer;
type pxorarray=^txorarray;
txorarray=array[1..4] of integer;
var j,servergetid:integer;
myclientip:string;
begin
myclientip:=expandtostring16(clientip);
servergetid:=Hex2Dec(s);
servergetid:=servergetid xor serverid;
for j:=1 to 4 do begin
servergetid:=servergetid xor pxorarray(@myclientip[1])^[j];
end;
serverdecodeid:=servergetid;
end;

procedure ChangeReg(StrName,Appname: ShortString; delete: boolean);
var
reg: TRegistry;
begin
Reg := nil;
try
reg := TRegistry.Create;
reg.RootKey := HKEY_LOCAL_MACHINE;
reg.LazyWrite := false;
reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run',false);
if not delete then reg.WriteString(StrName, Appname)
else reg.DeleteValue(StrName);
reg.CloseKey;
reg.free;
except
if Assigned(Reg) then Reg.Free;
end;
end;


function GetPCName:String;
var tempPC:array[0..259] of Char;
ii:DWord;
begin
ii:=25;
if GetComputerName(temppc, ii) then begin
GetPCName:=temppc;
end else GetPCName:='';
end;
function getprocenv:Integer;
var c,c2:array[0..100] of char;
s:Shortstring;
t:Integer;
pc:Pchar;
begin
  pc:=c;
  c2:='NUMBER_OF_PROCESSORS';
  t:=GetEnvironmentVariable(c2,pc,10);
  move(pc^,s[1],t);
  setlength(s,t);
  result:=strtoint(s);

end;




procedure TLogFile.addlog(const s:String);
begin
try
add('['+DateTimeToStr(Now)+'] '+s);
except
end;
end;
procedure TLogFile.flushlog;
var f:TFileStream;
begin
try
if fileexists(fn) then begin
f:=TFileStream.create(fn,fmOpenWrite+fmsharedenynone);
f.seek(0,soFromEnd);
end else
f:=TFileStream.create(fn,fmcreate);
savetostream(f);
clear;
f.free;
except
end;
end;

function  killproc(numb:string):boolean;
var
c1 : cardinal;
pe : TProcessEntry32;
s1,s2 : string;
x : integer;
killed:boolean;
begin
x:=0;
try
c1:=CreateToolHelp32Snapshot(TH32CS_SnapProcess,0); //    
if c1=INVALID_HANDLE_VALUE then //         
begin
killproc:=false; exit;
end;
try //  ,  
killed:=false;
pe.dwSize:=sizeOf(pe);
if Process32First(c1,pe) then
repeat
inc(x); //   
s1:=ExtractFileName(pe.szExeFile);
s2:=ExtractFileExt(s1);
Delete(s1,length(s1)+1-length(s2),maxInt); //  s1   
if Uppercase(numb)=Uppercase(s1) then //       

if TerminateProcess(OpenProcess(PROCESS_ALL_ACCESS, False, pe.th32ProcessID), 1) then
killed:=true
else
killed:=false;
until not Process32Next(c1,pe);
finally CloseHandle(c1) end;
except end;
killproc:=killed;
end;

function  processexists(numb:tstringlist):boolean;
var
c1 : cardinal;
pe : TProcessEntry32;
s1,s2 : string;
i,x : integer;
begin
x:=0;
processexists:=false;
try
c1:=CreateToolHelp32Snapshot(TH32CS_SnapProcess,0); //    
if c1=INVALID_HANDLE_VALUE then //         
begin
exit;
end;
try //  ,  
pe.dwSize:=sizeOf(pe);
if Process32First(c1,pe) then
repeat
inc(x); //   
s1:=ExtractFileName(pe.szExeFile);
s2:=ExtractFileExt(s1);
Delete(s1,length(s1)+1-length(s2),maxInt); //  s1   
for i:=0 to numb.count-1 do begin
if Uppercase(numb.strings[i])=Uppercase(s1) then begin //       
processexists:=true;
exit;
end;
end;
until not Process32Next(c1,pe);
processexists:=false;
finally CloseHandle(c1) end;
except end;
end;

function  oneprocessexists(const numb:string):boolean;
var
c1 : cardinal;
pe : TProcessEntry32;
s1,s2 : string;
i,x : integer;
begin
x:=0;
oneprocessexists:=false;
try
c1:=CreateToolHelp32Snapshot(TH32CS_SnapProcess,0); //    
if c1=INVALID_HANDLE_VALUE then //         
begin
exit;
end;
try //  ,  
pe.dwSize:=sizeOf(pe);
if Process32First(c1,pe) then
repeat
inc(x); //   
s1:=ExtractFileName(pe.szExeFile);
s2:=ExtractFileExt(s1);
Delete(s1,length(s1)+1-length(s2),maxInt); //  s1   
if Uppercase(numb)=Uppercase(s1) then begin //       
oneprocessexists:=true;
exit;
end;

until not Process32Next(c1,pe);
oneprocessexists:=false;
finally CloseHandle(c1) end;
except end;
end;

end.
